#! /usr/bin/env python3

import socket
import os, os.path
import time
from random import randint

def processNewIRI(datagram, connection):
	msgs = [s.strip() for s in datagram.splitlines()]
	msgs_iter = iter(msgs)

	for i in msgs_iter:
		try:
			msg = eval(i)
		except:
			continue
		print (i)
		if len(msg) == 5:
			moduleID, _,iriType, _,nidArray = msg    
		elif len(msg) == 6:
			moduleID, _,iriType, _,nidArray,returningPart = msg
			try:
				rand = randint(0,99)
				if rand < 30:
					print("send feedback")
					#connection.sendall(str(returningPart)+"\n")
					#TODO connection.sendall( ( str(returningPart)+"\n" ).encode('UTF-8') )
				else:
					pass
#				connection_for_ccci.sendall(str(returningPart)+"\n")
			except Exception as e:
				print("wtf")
				print (str(e))




def main():
	if os.path.exists("/tmp/iricol"):
		os.remove("/tmp/iricol")
#	if os.path.exists("/tmp/test_iri_core_ccci"):
#		os.remove("/tmp/test_iri_core_ccci")

	print ("Opening socket...")
	server_for_iri = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
	server_for_iri.bind("/tmp/iricol")
	server_for_iri.listen(1)
	
#	server_for_ccci = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
#	server_for_ccci.bind("/tmp/test_iri_core_ccci")
#	server_for_ccci.listen(1)
#	connection_for_ccci, client_address_for_ccci = server_for_ccci.accept()
#	
	try:
		while True:
			print ("Listening...")
			try:
				connection, client_address = server_for_iri.accept()
				while True:
					datagram = connection.recv(1024)
					if not datagram:
						break
					else:
		#				print ("-" * 20)
						processNewIRI(datagram, connection)
		#				print (datagram)
			except KeyboardInterrupt:
				break
	except KeyboardInterrupt:
		pass

#	print ("-" * 20)
	print ("Shutting down...")
	server_for_iri.close()
#	server_for_ccci.close()
	os.remove( "/tmp/iricol" )
#	os.remove("/tmp/test_iri_core_ccci")
	print ("Done")


#vykonani programu
if __name__ == "__main__":
	main()
