/*
 * Soubor:  iri-iif-adb.h
 * Datum:   27.05.2014
 * Autor:   Stanislav Bárta, xbarta29@stud.fit.vutbr.cz
 * Projekt: IRI-IIF pro SDM
 * Popis:   hlavickovy soubor pro funkce pro spravu aplikacniho zpozdovaciho bufferu
 */

#ifndef _IRI_IIF_ADB_
#define _IRI_IIF_ADB_

#include "header-files.h"

#define REPLY_LEN 140
#define BYTES_PER_RECORD 150


typedef struct iri_iif_adb_args_s
{
	int iri_iif_socket; // socket na IRI-core
	itc_ptr interface_for_adb; // rozhranie na zotriedene (podla cisla vlakna) IRI odpovede
} iri_iif_adb_args_t;


void iri_iif_adb_free(iri_iif_hash_table_item_t * input_hashTableRecord);
void *iri_iif_adb_listener(void *args);
void iri_iif_adb_insert_packet(iri_iif_hash_table_item_t *flow_record, iri_iif_offsets_t *offsets, ini3payload_t *packet);
void iri_iif_adb_check_iterfaces( );
void iri_iif_adb_init( int, itc_ptr, itc_ptr );

#endif
