/*
 * Soubor:  test_modul.c
 * Datum:   27.05.2014
 * Autor:   Stanislav Bárta, xbarta29@stud.fit.vutbr.cz
 * Projekt: Testovací modul pro SDM
 * Popis:   soubor obsahujici funkce rozhrani testovaciho aplikacniho modulu
 */

#include "test_modul.h"


int iri_iif_socket;
/*
void test_modul_init(int socket)
{
	iri_iif_socket = socket;
	srand(time(NULL));
}
*/
/*
void next(iri_iif_hash_table_item_t *table_item, iri_iif_offsets_t *offsets, ini3payload_t *packet, iri_iif_module_test_data_ptr * input_dataPointer)
{
	#ifdef IRI_IIF_DEBUG
		printf("%s %d: next() \n", __FILE__, __LINE__);
	#endif
	
	#ifdef IRI_IIF_DEBUG
		printf("%s %d: a-%u,b-%u\n", __FILE__, __LINE__, (*input_dataPointer)->a, (*input_dataPointer)->b);
	#endif
	unsigned int b = rand();
	(*input_dataPointer)->b = b;
	#ifdef IRI_IIF_DEBUG
		printf("%s %d: a-%u,b-%u\n", __FILE__, __LINE__, (*input_dataPointer)->a, (*input_dataPointer)->b);
	#endif
	
	
	
	
	char vysledne_iri[1000];

	char port_str[20];
	sprintf(port_str, "%d", table_item->key.items.port_1);
	char port_2_str[20];
	sprintf(port_2_str, "%d", table_item->key.items.port_1);
	char proto_str[20];
	if(table_item->key.items.proto == 6) // TCP
	{
		sprintf(proto_str, "TCP");
	}
	else if(table_item->key.items.proto == 17) // UDP
	{
		sprintf(proto_str, "UDP");
	}


	char adresa_str[INET6_ADDRSTRLEN];
	char adresa_2_str[INET6_ADDRSTRLEN];
	if(offsets->ip_ver == 4)
	{
		inet_ntop(AF_INET, table_item->key.items.ip_1.v4_long.data.d8, adresa_str, INET6_ADDRSTRLEN);
		inet_ntop(AF_INET, table_item->key.items.ip_2.v4_long.data.d8, adresa_2_str, INET6_ADDRSTRLEN);
	}
	else if(offsets->ip_ver == 6)
	{
		inet_ntop(AF_INET6, table_item->key.items.ip_1.v6.d8, adresa_str, INET6_ADDRSTRLEN);
		inet_ntop(AF_INET6, table_item->key.items.ip_2.v6.d8, adresa_2_str, INET6_ADDRSTRLEN);
	}

	char timestamp[60];
	sprintf(timestamp, "%ld.%ld", (long int)packet->header.timestamp_sec, (long int)packet->header.timestamp_ns);

	int r = rand() % 100;
	if(r < 20)
	{
		sprintf(vysledne_iri, "(\"TEST\", %s, \"REPORT\", \"description\", [(\"%s\", (\"%s\", %s, \"%s\", %s))]", timestamp, proto_str, adresa_str, port_str, adresa_2_str, port_2_str);
		iri_iif_modules_send_iri_message(vysledne_iri, 0, table_item, offsets->ip_ver);
	}
	else if(r < 40)
	{
		sprintf(vysledne_iri, "(\"TEST\", %s, \"CONTINUE\", \"description\", [(\"%s\", (\"%s\", %s, \"%s\", %s))]", timestamp, proto_str, adresa_str, port_str, adresa_2_str, port_2_str);
		iri_iif_modules_send_iri_message(vysledne_iri, 0, table_item, offsets->ip_ver);
	}
	else if(r < 60)
	{
		sprintf(vysledne_iri, "(\"TEST\", %s, \"END\", \"description\", [(\"%s\", (\"%s\", %s, \"%s\", %s))]", timestamp, proto_str, adresa_str, port_str, adresa_2_str, port_2_str);
		iri_iif_modules_send_iri_message(vysledne_iri, 0, table_item, offsets->ip_ver);
	}
	else if(r < 80)
	{
		sprintf(vysledne_iri, "(\"TEST\", %s, \"BEGIN\", \"description\", [(\"%s\", (\"%s\", %s, \"%s\", %s))]", timestamp, proto_str, adresa_str, port_str, adresa_2_str, port_2_str);
		iri_iif_modules_send_iri_message(vysledne_iri, 1, table_item, offsets->ip_ver);
	}
	else
	{
		return;
	}
}
*/

int test_modul_process_packet(iri_iif_hash_table_item_t *table_item, iri_iif_offsets_t *offsets, unsigned char *packet, uint16_t packet_size, void * input_dataPointer)
{
    printf("TEST_MODUL:");
    int i;
    for(i = 0; i < packet_size; i++)
    {
        if( *(packet + i) > 32 && *(packet + i) < 127 )
            printf("%c", *(packet + i));
        else
            printf(".");
    }
    printf(")\n");
    return MODULE_WANTS_TO_ANALYZE_THIS_FLOW;
    /*
	iri_iif_module_test_data_ptr * dataPointer = (iri_iif_module_test_data_ptr *) input_dataPointer;
	int r;
	
	#ifdef IRI_IIF_DEBUG
		int i;
		printf("%d:", __LINE__);
		for(i = 0; i < (packet)->header.blob_size; i++)
		{
			if( *((packet)->data + i) > 32 && *((packet)->data + i) < 127 )
				printf("%c", *((packet)->data + i));
			else
				printf(".");
		}
		printf("\n");
	#endif
	
	// novy tok
	if( *dataPointer == NULL)
	{
		// hned pri prvom pakete viem, ze dany tok nie je pre mna
		r = rand() % 100;
		if( r < 80)
			return MODULE_WANTS_TO_FILTER_THIS_FLOW;
		
		// mozno to teda je tok pre mna, vytvorim si zaznam
		*dataPointer = malloc( sizeof( struct iri_iif_module_test_dataS ) );
		
		// nahodim tam nejake pseudo data
		r = rand();
		(*dataPointer)->a = r;
		r = rand();
		(*dataPointer)->b = r;
		
		// hned pri prvom pakete vim, ze sa jedna o muj protokol
		r = rand() % 100;
		if( r < 40)
		{
			(*dataPointer)->deepAnalysis = 0;
			next(table_item, offsets, packet, dataPointer);
		}
		else // ked to nevim musim vykonat hlbkovu analyzu
			(*dataPointer)->deepAnalysis = 1;
		
		
		// modul chce dalsi pakety
		return MODULE_WANTS_TO_ANALYZE_THIS_FLOW;
	}
	// stary tok
	else
	{
		// este si nejsem isty ci sa jedna o muj tok
		if( (*dataPointer)->deepAnalysis == 1 )
		{
			r = rand() % 100;
			// nakonec sa o muj tok naozaj jedna
			if( r < 60)
			{
				(*dataPointer)->deepAnalysis = 0;
				next(table_item, offsets, packet, dataPointer);
			}
			// nakonec sa o muj tok nejedna
			else if ( r < 90 )
			{
				return MODULE_WANTS_TO_ANALYZE_THIS_FLOW;
			}
			// ziadna zmena, mozno to je muj tok a mozno ne
		}
		else
		{
			next(table_item, offsets, packet, dataPointer);
		}
		return MODULE_WANTS_TO_ANALYZE_THIS_FLOW;
	}
    */
}

void test_modul_process_end_of_flow( iri_iif_hash_table_item_t *table_item, void * data )
{
    
}

int test_modul_destroy_data( iri_iif_hash_table_item_t *table_item, void * data )
{
    /*
	iri_iif_module_test_data_ptr * data2 = (iri_iif_module_test_data_ptr *) data;
	free( *data2 );
	*data2 = NULL;
	*/
	// navratova hodnota nema zadny vyznam, len utisuje prekladac
	return TRUE;
}

