/**
 * \file commands.h
 * \brief 
 * \author Roman Vrana, xvrana20@stud.fit.vutbr.cz
 * \version 
 * \date 2015-02-23
 */

#include "msg_types.h"

#ifndef COMMANDS_H
#define COMMANDS_H

#define COMMAND_COUNT 8

typedef int(*cmd_t)(void *, void *, void *);

void populate_commands(cmd_t *vector);

int probe_start(void *in, void *out, void *others);
int probe_stop(void *in, void *out, void *others);
int probe_restart(void *in, void *out, void *others);
int probe_report(void *in, void *out, void *others);

#endif /* COMMANDS_H */
