#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <time.h>

#include "log_reader.h"

int main (int argc, char **argv)
{
    log_reader_t rd;
    int log_fd;

    rd.min_severity = 0;

    log_fd = open("/var/log/liprobe/probe_mon.log", O_RDONLY);

    for (int i = 0; i < MOD_COUNT; i++) {
        rd.last_logs_ts[i] = 0x0;
        rd.fds[i] = log_fd;
    }

    printf("0x%08x\n", reader_report(&rd, 0));

    reader_destroy(&rd);

    return 0;
}
