
/**
 * \file probe_monitor.h
 * \brief 
 * \author Roman Vrana, xvrana20@stud.fit.vutbr.cz
 * \date 2015-02-17
 */

#include "msg_types.h"

#ifndef MSG_PARSER_H
#define MSG_PARSER_H

#define UNKNOWN_DATA    255
#define ERROR_MEMORY    100
#define UNKNOWN_HEADER    1
#define PARSE_OK          0
#define SERIALIZE_OK      0

/**
 * \brief 
 *
 * \param buffer
 * \param 
 *
 * \return 
 */
int parse_header(unsigned char *buffer, msg_t *message);

/**
 * \brief 
 *
 * \param message
 *
 * \return 
 */
int parse_message(msg_t *message, unsigned char *data);
void clear_start_msg(start_msg_t *msg);

void create_response(unsigned char *response, int type, uint32_t probe_id,
                     int err_num, void *opt);
#endif /* MSG_PARSER_H */
