/**
 * \file inet_offsets.h
 * \brief Header file with constants for offseting data encapsilated
 * in ethernet frame.
 * \author Roman Vrana, xvrana20@stud.fit.vutbr.cz
 * \date 2014
 */

#ifndef INET_OFFSETS
#define INET_OFFSETS

#define SZE_FRAME_OFFSET 16

#define ETHER_LENGTH     14
#define ETHER_TYPE_OFF   12 // padding ??? (unpacked structure)
#define VLAN_TAG         4

#define IP4_START         12
#define IP4_LENGTH        4
#define IP4_PROTOCOL      9

#define IP6_START         8
#define IP6_LENGTH        16
#define IP6_H_LENGTH      40
#define IP6_PROTOCOL      6

#endif
