#ifndef PROBE_MONITOR_H
#define PROBE_MONITOR_H

#include "../../libs/error_logger/error_logger.h"

/* Path to UNIX socket for communication with configuration front-end */
#define SOCK_PATH "/tmp/probe_monitor_sck"

/* default/error socket */
#define COURIER_DEFAULT -255

/* Size of buffer for received commands */
#define BUFF_SIZE 256

/* PID files of probe monitor and probe modules */
#define PROBE_MON_PID_FILE    "/var/run/liprobe/probe_monitor.pid"
#define CCCID_PID_FILE        "/var/run/liprobe/cccid.pid"
#define FILTERD_PID_FILE      "/var/run/liprobe/filterd.pid"
#define INI3D_PID_FILE        "/var/run/liprobe/ini3d.pid"

/*File with probe_id */
#define PROBE_ID_FILE         "/etc/liprobe/probe_id"
extern logger_t *evt_log;

#endif /* PROBE_MONITOR_H */
